<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CO2ValueType Structs
 * Meta informations extracted from the WSDL
 * - documentation: Holds information about CO2 emission
 * @subpackage Structs
 */
class CO2ValueType extends AbstractStructBase
{
    /**
     * The unit
     * Meta informations extracted from the WSDL
     * - documentation: Holds information about CO2 emission unit
     * @var string
     */
    public $unit;
    /**
     * Constructor method for CO2ValueType
     * @uses CO2ValueType::setUnit()
     * @param string $unit
     */
    public function __construct($unit = null)
    {
        $this
            ->setUnit($unit);
    }
    /**
     * Get unit value
     * @return string|null
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @param string $unit
     * @return \Sabre\EnhancedAirBook\Structs\CO2ValueType
     */
    public function setUnit($unit = null)
    {
        $this->unit = $unit;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\CO2ValueType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
