<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Corporate Structs
 * @subpackage Structs
 */
class Corporate extends AbstractStructBase
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - documentation: "ID" is used to return the corporate ID associated with the particular hotel reservation if applicable. | "ID" is used to return the corporate ID associated with the vehicle reservation if applicable.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string
     */
    public $ID;
    /**
     * The Force
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $Force;
    /**
     * Constructor method for Corporate
     * @uses Corporate::setID()
     * @uses Corporate::setForce()
     * @param string $iD
     * @param string $force
     */
    public function __construct($iD = null, $force = null)
    {
        $this
            ->setID($iD)
            ->setForce($force);
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \Sabre\EnhancedAirBook\Structs\Corporate
     */
    public function setID($iD = null)
    {
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Force value
     * @return string|null
     */
    public function getForce()
    {
        return $this->Force;
    }
    /**
     * Set Force value
     * @param string $force
     * @return \Sabre\EnhancedAirBook\Structs\Corporate
     */
    public function setForce($force = null)
    {
        $this->Force = $force;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\Corporate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
