<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CountryCodes Structs
 * @subpackage Structs
 */
class CountryCodes extends AbstractStructBase
{
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Sabre\EnhancedAirBook\Structs\Code[]
     */
    public $Code;
    /**
     * Constructor method for CountryCodes
     * @uses CountryCodes::setCode()
     * @param \Sabre\EnhancedAirBook\Structs\Code[] $code
     */
    public function __construct(array $code = array())
    {
        $this
            ->setCode($code);
    }
    /**
     * Get Code value
     * @return \Sabre\EnhancedAirBook\Structs\Code[]|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Code[] $code
     * @return \Sabre\EnhancedAirBook\Structs\CountryCodes
     */
    public function setCode(array $code = array())
    {
        $this->Code = $code;
        return $this;
    }
    /**
     * Add item to Code value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Code $item
     * @return \Sabre\EnhancedAirBook\Structs\CountryCodes
     */
    public function addToCode(\Sabre\EnhancedAirBook\Structs\Code $item)
    {
        $this->Code[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\CountryCodes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
