<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Endorsements Structs
 * @subpackage Structs
 */
class Endorsements extends AbstractStructBase
{
    /**
     * The Text
     * Meta informations extracted from the WSDL
     * - maxOccurs: 20
     * - minOccurs: 0
     * @var string[]
     */
    public $Text;
    /**
     * The Override
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $Override;
    /**
     * The Endorsement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Endorsement[]
     */
    public $Endorsement;
    /**
     * Constructor method for Endorsements
     * @uses Endorsements::setText()
     * @uses Endorsements::setOverride()
     * @uses Endorsements::setEndorsement()
     * @param string[] $text
     * @param bool $override
     * @param \Sabre\EnhancedAirBook\Structs\Endorsement[] $endorsement
     */
    public function __construct(array $text = array(), $override = null, array $endorsement = array())
    {
        $this
            ->setText($text)
            ->setOverride($override)
            ->setEndorsement($endorsement);
    }
    /**
     * Get Text value
     * @return string[]|null
     */
    public function getText()
    {
        return $this->Text;
    }
    /**
     * Set Text value
     * @throws \InvalidArgumentException
     * @param string[] $text
     * @return \Sabre\EnhancedAirBook\Structs\Endorsements
     */
    public function setText(array $text = array())
    {
        $this->Text = $text;
        return $this;
    }
    /**
     * Add item to Text value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Sabre\EnhancedAirBook\Structs\Endorsements
     */
    public function addToText($item)
    {
        $this->Text[] = $item;
        return $this;
    }
    /**
     * Get Override value
     * @return bool|null
     */
    public function getOverride()
    {
        return $this->Override;
    }
    /**
     * Set Override value
     * @param bool $override
     * @return \Sabre\EnhancedAirBook\Structs\Endorsements
     */
    public function setOverride($override = null)
    {
        $this->Override = $override;
        return $this;
    }
    /**
     * Get Endorsement value
     * @return \Sabre\EnhancedAirBook\Structs\Endorsement[]|null
     */
    public function getEndorsement()
    {
        return $this->Endorsement;
    }
    /**
     * Set Endorsement value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Endorsement[] $endorsement
     * @return \Sabre\EnhancedAirBook\Structs\Endorsements
     */
    public function setEndorsement(array $endorsement = array())
    {
        $this->Endorsement = $endorsement;
        return $this;
    }
    /**
     * Add item to Endorsement value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Endorsement $item
     * @return \Sabre\EnhancedAirBook\Structs\Endorsements
     */
    public function addToEndorsement(\Sabre\EnhancedAirBook\Structs\Endorsement $item)
    {
        $this->Endorsement[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\Endorsements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
