<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EnhancedAirBookRS Structs
 * @subpackage Structs
 */
class EnhancedAirBookRS extends STL_Response_Payload
{
    /**
     * The AirTaxRS
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\AirTaxRS
     */
    public $AirTaxRS;
    /**
     * The OTA_AirBookRS
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\OTA_AirBookRS
     */
    public $OTA_AirBookRS;
    /**
     * The OTA_AirPriceRS
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\OTA_AirPriceRS
     */
    public $OTA_AirPriceRS;
    /**
     * The TravelItineraryReadRS
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\TravelItineraryReadRS
     */
    public $TravelItineraryReadRS;
    /**
     * Constructor method for EnhancedAirBookRS
     * @uses EnhancedAirBookRS::setAirTaxRS()
     * @uses EnhancedAirBookRS::setOTA_AirBookRS()
     * @uses EnhancedAirBookRS::setOTA_AirPriceRS()
     * @uses EnhancedAirBookRS::setTravelItineraryReadRS()
     * @param \Sabre\EnhancedAirBook\Structs\AirTaxRS $airTaxRS
     * @param \Sabre\EnhancedAirBook\Structs\OTA_AirBookRS $oTA_AirBookRS
     * @param \Sabre\EnhancedAirBook\Structs\OTA_AirPriceRS $oTA_AirPriceRS
     * @param \Sabre\EnhancedAirBook\Structs\TravelItineraryReadRS $travelItineraryReadRS
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\AirTaxRS $airTaxRS = null, \Sabre\EnhancedAirBook\Structs\OTA_AirBookRS $oTA_AirBookRS = null, \Sabre\EnhancedAirBook\Structs\OTA_AirPriceRS $oTA_AirPriceRS = null, \Sabre\EnhancedAirBook\Structs\TravelItineraryReadRS $travelItineraryReadRS = null)
    {
        $this
            ->setAirTaxRS($airTaxRS)
            ->setOTA_AirBookRS($oTA_AirBookRS)
            ->setOTA_AirPriceRS($oTA_AirPriceRS)
            ->setTravelItineraryReadRS($travelItineraryReadRS);
    }
    /**
     * Get AirTaxRS value
     * @return \Sabre\EnhancedAirBook\Structs\AirTaxRS|null
     */
    public function getAirTaxRS()
    {
        return $this->AirTaxRS;
    }
    /**
     * Set AirTaxRS value
     * @param \Sabre\EnhancedAirBook\Structs\AirTaxRS $airTaxRS
     * @return \Sabre\EnhancedAirBook\Structs\EnhancedAirBookRS
     */
    public function setAirTaxRS(\Sabre\EnhancedAirBook\Structs\AirTaxRS $airTaxRS = null)
    {
        $this->AirTaxRS = $airTaxRS;
        return $this;
    }
    /**
     * Get OTA_AirBookRS value
     * @return \Sabre\EnhancedAirBook\Structs\OTA_AirBookRS|null
     */
    public function getOTA_AirBookRS()
    {
        return $this->OTA_AirBookRS;
    }
    /**
     * Set OTA_AirBookRS value
     * @param \Sabre\EnhancedAirBook\Structs\OTA_AirBookRS $oTA_AirBookRS
     * @return \Sabre\EnhancedAirBook\Structs\EnhancedAirBookRS
     */
    public function setOTA_AirBookRS(\Sabre\EnhancedAirBook\Structs\OTA_AirBookRS $oTA_AirBookRS = null)
    {
        $this->OTA_AirBookRS = $oTA_AirBookRS;
        return $this;
    }
    /**
     * Get OTA_AirPriceRS value
     * @return \Sabre\EnhancedAirBook\Structs\OTA_AirPriceRS|null
     */
    public function getOTA_AirPriceRS()
    {
        return $this->OTA_AirPriceRS;
    }
    /**
     * Set OTA_AirPriceRS value
     * @param \Sabre\EnhancedAirBook\Structs\OTA_AirPriceRS $oTA_AirPriceRS
     * @return \Sabre\EnhancedAirBook\Structs\EnhancedAirBookRS
     */
    public function setOTA_AirPriceRS(\Sabre\EnhancedAirBook\Structs\OTA_AirPriceRS $oTA_AirPriceRS = null)
    {
        $this->OTA_AirPriceRS = $oTA_AirPriceRS;
        return $this;
    }
    /**
     * Get TravelItineraryReadRS value
     * @return \Sabre\EnhancedAirBook\Structs\TravelItineraryReadRS|null
     */
    public function getTravelItineraryReadRS()
    {
        return $this->TravelItineraryReadRS;
    }
    /**
     * Set TravelItineraryReadRS value
     * @param \Sabre\EnhancedAirBook\Structs\TravelItineraryReadRS $travelItineraryReadRS
     * @return \Sabre\EnhancedAirBook\Structs\EnhancedAirBookRS
     */
    public function setTravelItineraryReadRS(\Sabre\EnhancedAirBook\Structs\TravelItineraryReadRS $travelItineraryReadRS = null)
    {
        $this->TravelItineraryReadRS = $travelItineraryReadRS;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\EnhancedAirBookRS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
