<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareDescription Structs
 * @subpackage Structs
 */
class FareDescription extends AbstractStructBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The Detail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $Detail;
    /**
     * The Condition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Condition[]
     */
    public $Condition;
    /**
     * The Fees
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Fees
     */
    public $Fees;
    /**
     * Constructor method for FareDescription
     * @uses FareDescription::setName()
     * @uses FareDescription::setCode()
     * @uses FareDescription::setDetail()
     * @uses FareDescription::setCondition()
     * @uses FareDescription::setFees()
     * @param string $name
     * @param string $code
     * @param string[] $detail
     * @param \Sabre\EnhancedAirBook\Structs\Condition[] $condition
     * @param \Sabre\EnhancedAirBook\Structs\Fees $fees
     */
    public function __construct($name = null, $code = null, array $detail = array(), array $condition = array(), \Sabre\EnhancedAirBook\Structs\Fees $fees = null)
    {
        $this
            ->setName($name)
            ->setCode($code)
            ->setDetail($detail)
            ->setCondition($condition)
            ->setFees($fees);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \Sabre\EnhancedAirBook\Structs\FareDescription
     */
    public function setName($name = null)
    {
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \Sabre\EnhancedAirBook\Structs\FareDescription
     */
    public function setCode($code = null)
    {
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Detail value
     * @return string[]|null
     */
    public function getDetail()
    {
        return $this->Detail;
    }
    /**
     * Set Detail value
     * @throws \InvalidArgumentException
     * @param string[] $detail
     * @return \Sabre\EnhancedAirBook\Structs\FareDescription
     */
    public function setDetail(array $detail = array())
    {
        $this->Detail = $detail;
        return $this;
    }
    /**
     * Add item to Detail value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Sabre\EnhancedAirBook\Structs\FareDescription
     */
    public function addToDetail($item)
    {
        $this->Detail[] = $item;
        return $this;
    }
    /**
     * Get Condition value
     * @return \Sabre\EnhancedAirBook\Structs\Condition[]|null
     */
    public function getCondition()
    {
        return $this->Condition;
    }
    /**
     * Set Condition value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Condition[] $condition
     * @return \Sabre\EnhancedAirBook\Structs\FareDescription
     */
    public function setCondition(array $condition = array())
    {
        $this->Condition = $condition;
        return $this;
    }
    /**
     * Add item to Condition value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Condition $item
     * @return \Sabre\EnhancedAirBook\Structs\FareDescription
     */
    public function addToCondition(\Sabre\EnhancedAirBook\Structs\Condition $item)
    {
        $this->Condition[] = $item;
        return $this;
    }
    /**
     * Get Fees value
     * @return \Sabre\EnhancedAirBook\Structs\Fees|null
     */
    public function getFees()
    {
        return $this->Fees;
    }
    /**
     * Set Fees value
     * @param \Sabre\EnhancedAirBook\Structs\Fees $fees
     * @return \Sabre\EnhancedAirBook\Structs\FareDescription
     */
    public function setFees(\Sabre\EnhancedAirBook\Structs\Fees $fees = null)
    {
        $this->Fees = $fees;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\FareDescription
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
