<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareOptions Structs
 * @subpackage Structs
 */
class FareOptions extends AbstractStructBase
{
    /**
     * The ASLBreakdown
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $ASLBreakdown;
    /**
     * The ASLIgnore
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $ASLIgnore;
    /**
     * The Excursion
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $Excursion;
    /**
     * The Net
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $Net;
    /**
     * The Private
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $Private;
    /**
     * The Public
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $Public;
    /**
     * Constructor method for FareOptions
     * @uses FareOptions::setASLBreakdown()
     * @uses FareOptions::setASLIgnore()
     * @uses FareOptions::setExcursion()
     * @uses FareOptions::setNet()
     * @uses FareOptions::setPrivate()
     * @uses FareOptions::setPublic()
     * @param bool $aSLBreakdown
     * @param bool $aSLIgnore
     * @param bool $excursion
     * @param bool $net
     * @param bool $private
     * @param bool $public
     */
    public function __construct($aSLBreakdown = null, $aSLIgnore = null, $excursion = null, $net = null, $private = null, $public = null)
    {
        $this
            ->setASLBreakdown($aSLBreakdown)
            ->setASLIgnore($aSLIgnore)
            ->setExcursion($excursion)
            ->setNet($net)
            ->setPrivate($private)
            ->setPublic($public);
    }
    /**
     * Get ASLBreakdown value
     * @return bool|null
     */
    public function getASLBreakdown()
    {
        return $this->ASLBreakdown;
    }
    /**
     * Set ASLBreakdown value
     * @param bool $aSLBreakdown
     * @return \Sabre\EnhancedAirBook\Structs\FareOptions
     */
    public function setASLBreakdown($aSLBreakdown = null)
    {
        $this->ASLBreakdown = $aSLBreakdown;
        return $this;
    }
    /**
     * Get ASLIgnore value
     * @return bool|null
     */
    public function getASLIgnore()
    {
        return $this->ASLIgnore;
    }
    /**
     * Set ASLIgnore value
     * @param bool $aSLIgnore
     * @return \Sabre\EnhancedAirBook\Structs\FareOptions
     */
    public function setASLIgnore($aSLIgnore = null)
    {
        $this->ASLIgnore = $aSLIgnore;
        return $this;
    }
    /**
     * Get Excursion value
     * @return bool|null
     */
    public function getExcursion()
    {
        return $this->Excursion;
    }
    /**
     * Set Excursion value
     * @param bool $excursion
     * @return \Sabre\EnhancedAirBook\Structs\FareOptions
     */
    public function setExcursion($excursion = null)
    {
        $this->Excursion = $excursion;
        return $this;
    }
    /**
     * Get Net value
     * @return bool|null
     */
    public function getNet()
    {
        return $this->Net;
    }
    /**
     * Set Net value
     * @param bool $net
     * @return \Sabre\EnhancedAirBook\Structs\FareOptions
     */
    public function setNet($net = null)
    {
        $this->Net = $net;
        return $this;
    }
    /**
     * Get Private value
     * @return bool|null
     */
    public function getPrivate()
    {
        return $this->Private;
    }
    /**
     * Set Private value
     * @param bool $private
     * @return \Sabre\EnhancedAirBook\Structs\FareOptions
     */
    public function setPrivate($private = null)
    {
        $this->Private = $private;
        return $this;
    }
    /**
     * Get Public value
     * @return bool|null
     */
    public function getPublic()
    {
        return $this->Public;
    }
    /**
     * Set Public value
     * @param bool $public
     * @return \Sabre\EnhancedAirBook\Structs\FareOptions
     */
    public function setPublic($public = null)
    {
        $this->Public = $public;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\FareOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
