<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FuturePricingInfo Structs
 * Meta informations extracted from the WSDL
 * - documentation: "FuturePricingInfo" is used to reflect Future pricing information
 * @subpackage Structs
 */
class FuturePricingInfo extends AbstractStructBase
{
    /**
     * The FuturePrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\FuturePrice[]
     */
    public $FuturePrice;
    /**
     * Constructor method for FuturePricingInfo
     * @uses FuturePricingInfo::setFuturePrice()
     * @param \Sabre\EnhancedAirBook\Structs\FuturePrice[] $futurePrice
     */
    public function __construct(array $futurePrice = array())
    {
        $this
            ->setFuturePrice($futurePrice);
    }
    /**
     * Get FuturePrice value
     * @return \Sabre\EnhancedAirBook\Structs\FuturePrice[]|null
     */
    public function getFuturePrice()
    {
        return $this->FuturePrice;
    }
    /**
     * Set FuturePrice value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\FuturePrice[] $futurePrice
     * @return \Sabre\EnhancedAirBook\Structs\FuturePricingInfo
     */
    public function setFuturePrice(array $futurePrice = array())
    {
        $this->FuturePrice = $futurePrice;
        return $this;
    }
    /**
     * Add item to FuturePrice value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\FuturePrice $item
     * @return \Sabre\EnhancedAirBook\Structs\FuturePricingInfo
     */
    public function addToFuturePrice(\Sabre\EnhancedAirBook\Structs\FuturePrice $item)
    {
        $this->FuturePrice[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\FuturePricingInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
