<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GlobalNetRemit Structs
 * @subpackage Structs
 */
class GlobalNetRemit extends AbstractStructBase
{
    /**
     * The NetFare
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\NetFare
     */
    public $NetFare;
    /**
     * The SellingFare
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\SellingFare
     */
    public $SellingFare;
    /**
     * The Text
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Text;
    /**
     * The MethodType
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $MethodType;
    /**
     * The ValueCode
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $ValueCode;
    /**
     * Constructor method for GlobalNetRemit
     * @uses GlobalNetRemit::setNetFare()
     * @uses GlobalNetRemit::setSellingFare()
     * @uses GlobalNetRemit::setText()
     * @uses GlobalNetRemit::setMethodType()
     * @uses GlobalNetRemit::setValueCode()
     * @param \Sabre\EnhancedAirBook\Structs\NetFare $netFare
     * @param \Sabre\EnhancedAirBook\Structs\SellingFare $sellingFare
     * @param string $text
     * @param string $methodType
     * @param string $valueCode
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\NetFare $netFare = null, \Sabre\EnhancedAirBook\Structs\SellingFare $sellingFare = null, $text = null, $methodType = null, $valueCode = null)
    {
        $this
            ->setNetFare($netFare)
            ->setSellingFare($sellingFare)
            ->setText($text)
            ->setMethodType($methodType)
            ->setValueCode($valueCode);
    }
    /**
     * Get NetFare value
     * @return \Sabre\EnhancedAirBook\Structs\NetFare|null
     */
    public function getNetFare()
    {
        return $this->NetFare;
    }
    /**
     * Set NetFare value
     * @param \Sabre\EnhancedAirBook\Structs\NetFare $netFare
     * @return \Sabre\EnhancedAirBook\Structs\GlobalNetRemit
     */
    public function setNetFare(\Sabre\EnhancedAirBook\Structs\NetFare $netFare = null)
    {
        $this->NetFare = $netFare;
        return $this;
    }
    /**
     * Get SellingFare value
     * @return \Sabre\EnhancedAirBook\Structs\SellingFare|null
     */
    public function getSellingFare()
    {
        return $this->SellingFare;
    }
    /**
     * Set SellingFare value
     * @param \Sabre\EnhancedAirBook\Structs\SellingFare $sellingFare
     * @return \Sabre\EnhancedAirBook\Structs\GlobalNetRemit
     */
    public function setSellingFare(\Sabre\EnhancedAirBook\Structs\SellingFare $sellingFare = null)
    {
        $this->SellingFare = $sellingFare;
        return $this;
    }
    /**
     * Get Text value
     * @return string|null
     */
    public function getText()
    {
        return $this->Text;
    }
    /**
     * Set Text value
     * @param string $text
     * @return \Sabre\EnhancedAirBook\Structs\GlobalNetRemit
     */
    public function setText($text = null)
    {
        $this->Text = $text;
        return $this;
    }
    /**
     * Get MethodType value
     * @return string|null
     */
    public function getMethodType()
    {
        return $this->MethodType;
    }
    /**
     * Set MethodType value
     * @param string $methodType
     * @return \Sabre\EnhancedAirBook\Structs\GlobalNetRemit
     */
    public function setMethodType($methodType = null)
    {
        $this->MethodType = $methodType;
        return $this;
    }
    /**
     * Get ValueCode value
     * @return string|null
     */
    public function getValueCode()
    {
        return $this->ValueCode;
    }
    /**
     * Set ValueCode value
     * @param string $valueCode
     * @return \Sabre\EnhancedAirBook\Structs\GlobalNetRemit
     */
    public function setValueCode($valueCode = null)
    {
        $this->ValueCode = $valueCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\GlobalNetRemit
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
