<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelRateDescripton Structs
 * @subpackage Structs
 */
class HotelRateDescripton extends AbstractStructBase
{
    /**
     * The RateDescriptions
     * @var \Sabre\EnhancedAirBook\Structs\RateDescriptions
     */
    public $RateDescriptions;
    /**
     * The CancelationsPolicy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CancelationsPolicy;
    /**
     * The GuaranteePolicy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $GuaranteePolicy;
    /**
     * The DespositPolicy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DespositPolicy;
    /**
     * The LateArrivalPolicy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LateArrivalPolicy;
    /**
     * The Additionals
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Additionals
     */
    public $Additionals;
    /**
     * Constructor method for HotelRateDescripton
     * @uses HotelRateDescripton::setRateDescriptions()
     * @uses HotelRateDescripton::setCancelationsPolicy()
     * @uses HotelRateDescripton::setGuaranteePolicy()
     * @uses HotelRateDescripton::setDespositPolicy()
     * @uses HotelRateDescripton::setLateArrivalPolicy()
     * @uses HotelRateDescripton::setAdditionals()
     * @param \Sabre\EnhancedAirBook\Structs\RateDescriptions $rateDescriptions
     * @param string $cancelationsPolicy
     * @param string $guaranteePolicy
     * @param string $despositPolicy
     * @param string $lateArrivalPolicy
     * @param \Sabre\EnhancedAirBook\Structs\Additionals $additionals
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\RateDescriptions $rateDescriptions = null, $cancelationsPolicy = null, $guaranteePolicy = null, $despositPolicy = null, $lateArrivalPolicy = null, \Sabre\EnhancedAirBook\Structs\Additionals $additionals = null)
    {
        $this
            ->setRateDescriptions($rateDescriptions)
            ->setCancelationsPolicy($cancelationsPolicy)
            ->setGuaranteePolicy($guaranteePolicy)
            ->setDespositPolicy($despositPolicy)
            ->setLateArrivalPolicy($lateArrivalPolicy)
            ->setAdditionals($additionals);
    }
    /**
     * Get RateDescriptions value
     * @return \Sabre\EnhancedAirBook\Structs\RateDescriptions|null
     */
    public function getRateDescriptions()
    {
        return $this->RateDescriptions;
    }
    /**
     * Set RateDescriptions value
     * @param \Sabre\EnhancedAirBook\Structs\RateDescriptions $rateDescriptions
     * @return \Sabre\EnhancedAirBook\Structs\HotelRateDescripton
     */
    public function setRateDescriptions(\Sabre\EnhancedAirBook\Structs\RateDescriptions $rateDescriptions = null)
    {
        $this->RateDescriptions = $rateDescriptions;
        return $this;
    }
    /**
     * Get CancelationsPolicy value
     * @return string|null
     */
    public function getCancelationsPolicy()
    {
        return $this->CancelationsPolicy;
    }
    /**
     * Set CancelationsPolicy value
     * @param string $cancelationsPolicy
     * @return \Sabre\EnhancedAirBook\Structs\HotelRateDescripton
     */
    public function setCancelationsPolicy($cancelationsPolicy = null)
    {
        $this->CancelationsPolicy = $cancelationsPolicy;
        return $this;
    }
    /**
     * Get GuaranteePolicy value
     * @return string|null
     */
    public function getGuaranteePolicy()
    {
        return $this->GuaranteePolicy;
    }
    /**
     * Set GuaranteePolicy value
     * @param string $guaranteePolicy
     * @return \Sabre\EnhancedAirBook\Structs\HotelRateDescripton
     */
    public function setGuaranteePolicy($guaranteePolicy = null)
    {
        $this->GuaranteePolicy = $guaranteePolicy;
        return $this;
    }
    /**
     * Get DespositPolicy value
     * @return string|null
     */
    public function getDespositPolicy()
    {
        return $this->DespositPolicy;
    }
    /**
     * Set DespositPolicy value
     * @param string $despositPolicy
     * @return \Sabre\EnhancedAirBook\Structs\HotelRateDescripton
     */
    public function setDespositPolicy($despositPolicy = null)
    {
        $this->DespositPolicy = $despositPolicy;
        return $this;
    }
    /**
     * Get LateArrivalPolicy value
     * @return string|null
     */
    public function getLateArrivalPolicy()
    {
        return $this->LateArrivalPolicy;
    }
    /**
     * Set LateArrivalPolicy value
     * @param string $lateArrivalPolicy
     * @return \Sabre\EnhancedAirBook\Structs\HotelRateDescripton
     */
    public function setLateArrivalPolicy($lateArrivalPolicy = null)
    {
        $this->LateArrivalPolicy = $lateArrivalPolicy;
        return $this;
    }
    /**
     * Get Additionals value
     * @return \Sabre\EnhancedAirBook\Structs\Additionals|null
     */
    public function getAdditionals()
    {
        return $this->Additionals;
    }
    /**
     * Set Additionals value
     * @param \Sabre\EnhancedAirBook\Structs\Additionals $additionals
     * @return \Sabre\EnhancedAirBook\Structs\HotelRateDescripton
     */
    public function setAdditionals(\Sabre\EnhancedAirBook\Structs\Additionals $additionals = null)
    {
        $this->Additionals = $additionals;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\HotelRateDescripton
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
