<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MultilineTextType Structs
 * @subpackage Structs
 */
class MultilineTextType extends AbstractStructBase
{
    /**
     * The TextLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var string[]
     */
    public $TextLine;
    /**
     * Constructor method for MultilineTextType
     * @uses MultilineTextType::setTextLine()
     * @param string[] $textLine
     */
    public function __construct(array $textLine = array())
    {
        $this
            ->setTextLine($textLine);
    }
    /**
     * Get TextLine value
     * @return string[]
     */
    public function getTextLine()
    {
        return $this->TextLine;
    }
    /**
     * Set TextLine value
     * @throws \InvalidArgumentException
     * @param string[] $textLine
     * @return \Sabre\EnhancedAirBook\Structs\MultilineTextType
     */
    public function setTextLine(array $textLine = array())
    {
        $this->TextLine = $textLine;
        return $this;
    }
    /**
     * Add item to TextLine value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Sabre\EnhancedAirBook\Structs\MultilineTextType
     */
    public function addToTextLine($item)
    {
        $this->TextLine[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\MultilineTextType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
