<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MultipleFOP Structs
 * @subpackage Structs
 */
class MultipleFOP extends AbstractStructBase
{
    /**
     * The Fare
     * @var \Sabre\EnhancedAirBook\Structs\Fare
     */
    public $Fare;
    /**
     * The FOP_One
     * @var \Sabre\EnhancedAirBook\Structs\FOP_One
     */
    public $FOP_One;
    /**
     * The FOP_Two
     * @var \Sabre\EnhancedAirBook\Structs\FOP_Two
     */
    public $FOP_Two;
    /**
     * The Taxes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Taxes
     */
    public $Taxes;
    /**
     * Constructor method for MultipleFOP
     * @uses MultipleFOP::setFare()
     * @uses MultipleFOP::setFOP_One()
     * @uses MultipleFOP::setFOP_Two()
     * @uses MultipleFOP::setTaxes()
     * @param \Sabre\EnhancedAirBook\Structs\Fare $fare
     * @param \Sabre\EnhancedAirBook\Structs\FOP_One $fOP_One
     * @param \Sabre\EnhancedAirBook\Structs\FOP_Two $fOP_Two
     * @param \Sabre\EnhancedAirBook\Structs\Taxes $taxes
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\Fare $fare = null, \Sabre\EnhancedAirBook\Structs\FOP_One $fOP_One = null, \Sabre\EnhancedAirBook\Structs\FOP_Two $fOP_Two = null, \Sabre\EnhancedAirBook\Structs\Taxes $taxes = null)
    {
        $this
            ->setFare($fare)
            ->setFOP_One($fOP_One)
            ->setFOP_Two($fOP_Two)
            ->setTaxes($taxes);
    }
    /**
     * Get Fare value
     * @return \Sabre\EnhancedAirBook\Structs\Fare|null
     */
    public function getFare()
    {
        return $this->Fare;
    }
    /**
     * Set Fare value
     * @param \Sabre\EnhancedAirBook\Structs\Fare $fare
     * @return \Sabre\EnhancedAirBook\Structs\MultipleFOP
     */
    public function setFare(\Sabre\EnhancedAirBook\Structs\Fare $fare = null)
    {
        $this->Fare = $fare;
        return $this;
    }
    /**
     * Get FOP_One value
     * @return \Sabre\EnhancedAirBook\Structs\FOP_One|null
     */
    public function getFOP_One()
    {
        return $this->FOP_One;
    }
    /**
     * Set FOP_One value
     * @param \Sabre\EnhancedAirBook\Structs\FOP_One $fOP_One
     * @return \Sabre\EnhancedAirBook\Structs\MultipleFOP
     */
    public function setFOP_One(\Sabre\EnhancedAirBook\Structs\FOP_One $fOP_One = null)
    {
        $this->FOP_One = $fOP_One;
        return $this;
    }
    /**
     * Get FOP_Two value
     * @return \Sabre\EnhancedAirBook\Structs\FOP_Two|null
     */
    public function getFOP_Two()
    {
        return $this->FOP_Two;
    }
    /**
     * Set FOP_Two value
     * @param \Sabre\EnhancedAirBook\Structs\FOP_Two $fOP_Two
     * @return \Sabre\EnhancedAirBook\Structs\MultipleFOP
     */
    public function setFOP_Two(\Sabre\EnhancedAirBook\Structs\FOP_Two $fOP_Two = null)
    {
        $this->FOP_Two = $fOP_Two;
        return $this;
    }
    /**
     * Get Taxes value
     * @return \Sabre\EnhancedAirBook\Structs\Taxes|null
     */
    public function getTaxes()
    {
        return $this->Taxes;
    }
    /**
     * Set Taxes value
     * @param \Sabre\EnhancedAirBook\Structs\Taxes $taxes
     * @return \Sabre\EnhancedAirBook\Structs\MultipleFOP
     */
    public function setTaxes(\Sabre\EnhancedAirBook\Structs\Taxes $taxes = null)
    {
        $this->Taxes = $taxes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\MultipleFOP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
