<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OperatingAirline Structs
 * @subpackage Structs
 */
class OperatingAirline extends AbstractStructBase
{
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - documentation: "Code" is used to return the operating airline code associated with the particular flight segment.
     * - use: optional
     * @var string
     */
    public $Code;
    /**
     * The Banner
     * Meta informations extracted from the WSDL
     * - documentation: "OperatingAirline/Banner" is used to return the marketing airline name.
     * - minOccurs: 0
     * @var string
     */
    public $Banner;
    /**
     * The FlightNumber
     * Meta informations extracted from the WSDL
     * - documentation: "FlightNumber" is used to return the flight number associated with the operating airline's flight segment.
     * - use: optional
     * @var string
     */
    public $FlightNumber;
    /**
     * The ResBookDesigCode
     * Meta informations extracted from the WSDL
     * - documentation: "ResBookDesigCode" is used to return the booking class associated with the particular flight segment.
     * - use: optional
     * @var string
     */
    public $ResBookDesigCode;
    /**
     * The OwningCarrier
     * Meta informations extracted from the WSDL
     * - documentation: "OwningCarrier" is used to return the code of the airline that owns the flight, which can be different to the operator.
     * - use: optional
     * @var string
     */
    public $OwningCarrier;
    /**
     * Constructor method for OperatingAirline
     * @uses OperatingAirline::setCode()
     * @uses OperatingAirline::setBanner()
     * @uses OperatingAirline::setFlightNumber()
     * @uses OperatingAirline::setResBookDesigCode()
     * @uses OperatingAirline::setOwningCarrier()
     * @param string $code
     * @param string $banner
     * @param string $flightNumber
     * @param string $resBookDesigCode
     * @param string $owningCarrier
     */
    public function __construct($code = null, $banner = null, $flightNumber = null, $resBookDesigCode = null, $owningCarrier = null)
    {
        $this
            ->setCode($code)
            ->setBanner($banner)
            ->setFlightNumber($flightNumber)
            ->setResBookDesigCode($resBookDesigCode)
            ->setOwningCarrier($owningCarrier);
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \Sabre\EnhancedAirBook\Structs\OperatingAirline
     */
    public function setCode($code = null)
    {
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Banner value
     * @return string|null
     */
    public function getBanner()
    {
        return $this->Banner;
    }
    /**
     * Set Banner value
     * @param string $banner
     * @return \Sabre\EnhancedAirBook\Structs\OperatingAirline
     */
    public function setBanner($banner = null)
    {
        $this->Banner = $banner;
        return $this;
    }
    /**
     * Get FlightNumber value
     * @return string|null
     */
    public function getFlightNumber()
    {
        return $this->FlightNumber;
    }
    /**
     * Set FlightNumber value
     * @param string $flightNumber
     * @return \Sabre\EnhancedAirBook\Structs\OperatingAirline
     */
    public function setFlightNumber($flightNumber = null)
    {
        $this->FlightNumber = $flightNumber;
        return $this;
    }
    /**
     * Get ResBookDesigCode value
     * @return string|null
     */
    public function getResBookDesigCode()
    {
        return $this->ResBookDesigCode;
    }
    /**
     * Set ResBookDesigCode value
     * @param string $resBookDesigCode
     * @return \Sabre\EnhancedAirBook\Structs\OperatingAirline
     */
    public function setResBookDesigCode($resBookDesigCode = null)
    {
        $this->ResBookDesigCode = $resBookDesigCode;
        return $this;
    }
    /**
     * Get OwningCarrier value
     * @return string|null
     */
    public function getOwningCarrier()
    {
        return $this->OwningCarrier;
    }
    /**
     * Set OwningCarrier value
     * @param string $owningCarrier
     * @return \Sabre\EnhancedAirBook\Structs\OperatingAirline
     */
    public function setOwningCarrier($owningCarrier = null)
    {
        $this->OwningCarrier = $owningCarrier;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\OperatingAirline
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
