<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PassengerFare Structs
 * @subpackage Structs
 */
class PassengerFare extends AbstractStructBase
{
    /**
     * The BaseFare
     * @var \Sabre\EnhancedAirBook\Structs\BaseFare
     */
    public $BaseFare;
    /**
     * The EquivFare
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\EquivFare
     */
    public $EquivFare;
    /**
     * The AncillaryServiceCode
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $AncillaryServiceCode;
    /**
     * Constructor method for PassengerFare
     * @uses PassengerFare::setBaseFare()
     * @uses PassengerFare::setEquivFare()
     * @uses PassengerFare::setAncillaryServiceCode()
     * @param \Sabre\EnhancedAirBook\Structs\BaseFare $baseFare
     * @param \Sabre\EnhancedAirBook\Structs\EquivFare $equivFare
     * @param string $ancillaryServiceCode
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\BaseFare $baseFare = null, \Sabre\EnhancedAirBook\Structs\EquivFare $equivFare = null, $ancillaryServiceCode = null)
    {
        $this
            ->setBaseFare($baseFare)
            ->setEquivFare($equivFare)
            ->setAncillaryServiceCode($ancillaryServiceCode);
    }
    /**
     * Get BaseFare value
     * @return \Sabre\EnhancedAirBook\Structs\BaseFare|null
     */
    public function getBaseFare()
    {
        return $this->BaseFare;
    }
    /**
     * Set BaseFare value
     * @param \Sabre\EnhancedAirBook\Structs\BaseFare $baseFare
     * @return \Sabre\EnhancedAirBook\Structs\PassengerFare
     */
    public function setBaseFare(\Sabre\EnhancedAirBook\Structs\BaseFare $baseFare = null)
    {
        $this->BaseFare = $baseFare;
        return $this;
    }
    /**
     * Get EquivFare value
     * @return \Sabre\EnhancedAirBook\Structs\EquivFare|null
     */
    public function getEquivFare()
    {
        return $this->EquivFare;
    }
    /**
     * Set EquivFare value
     * @param \Sabre\EnhancedAirBook\Structs\EquivFare $equivFare
     * @return \Sabre\EnhancedAirBook\Structs\PassengerFare
     */
    public function setEquivFare(\Sabre\EnhancedAirBook\Structs\EquivFare $equivFare = null)
    {
        $this->EquivFare = $equivFare;
        return $this;
    }
    /**
     * Get AncillaryServiceCode value
     * @return string|null
     */
    public function getAncillaryServiceCode()
    {
        return $this->AncillaryServiceCode;
    }
    /**
     * Set AncillaryServiceCode value
     * @param string $ancillaryServiceCode
     * @return \Sabre\EnhancedAirBook\Structs\PassengerFare
     */
    public function setAncillaryServiceCode($ancillaryServiceCode = null)
    {
        $this->AncillaryServiceCode = $ancillaryServiceCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\PassengerFare
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
