<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlusUp Structs
 * @subpackage Structs
 */
class PlusUp extends AbstractStructBase
{
    /**
     * The Amount
     * Meta informations extracted from the WSDL
     * - use: required
     * @var string
     */
    public $Amount;
    /**
     * The TicketDesignator
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TicketDesignator;
    /**
     * Constructor method for PlusUp
     * @uses PlusUp::setAmount()
     * @uses PlusUp::setTicketDesignator()
     * @param string $amount
     * @param string $ticketDesignator
     */
    public function __construct($amount = null, $ticketDesignator = null)
    {
        $this
            ->setAmount($amount)
            ->setTicketDesignator($ticketDesignator);
    }
    /**
     * Get Amount value
     * @return string
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param string $amount
     * @return \Sabre\EnhancedAirBook\Structs\PlusUp
     */
    public function setAmount($amount = null)
    {
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get TicketDesignator value
     * @return string|null
     */
    public function getTicketDesignator()
    {
        return $this->TicketDesignator;
    }
    /**
     * Set TicketDesignator value
     * @param string $ticketDesignator
     * @return \Sabre\EnhancedAirBook\Structs\PlusUp
     */
    public function setTicketDesignator($ticketDesignator = null)
    {
        $this->TicketDesignator = $ticketDesignator;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\PlusUp
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
