<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PostProcessing Structs
 * @subpackage Structs
 */
class PostProcessing extends AbstractStructBase
{
    /**
     * The RedisplayReservation
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\RedisplayReservation
     */
    public $RedisplayReservation;
    /**
     * The IgnoreAfter
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $IgnoreAfter;
    /**
     * Constructor method for PostProcessing
     * @uses PostProcessing::setRedisplayReservation()
     * @uses PostProcessing::setIgnoreAfter()
     * @param \Sabre\EnhancedAirBook\Structs\RedisplayReservation $redisplayReservation
     * @param bool $ignoreAfter
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\RedisplayReservation $redisplayReservation = null, $ignoreAfter = null)
    {
        $this
            ->setRedisplayReservation($redisplayReservation)
            ->setIgnoreAfter($ignoreAfter);
    }
    /**
     * Get RedisplayReservation value
     * @return \Sabre\EnhancedAirBook\Structs\RedisplayReservation|null
     */
    public function getRedisplayReservation()
    {
        return $this->RedisplayReservation;
    }
    /**
     * Set RedisplayReservation value
     * @param \Sabre\EnhancedAirBook\Structs\RedisplayReservation $redisplayReservation
     * @return \Sabre\EnhancedAirBook\Structs\PostProcessing
     */
    public function setRedisplayReservation(\Sabre\EnhancedAirBook\Structs\RedisplayReservation $redisplayReservation = null)
    {
        $this->RedisplayReservation = $redisplayReservation;
        return $this;
    }
    /**
     * Get IgnoreAfter value
     * @return bool|null
     */
    public function getIgnoreAfter()
    {
        return $this->IgnoreAfter;
    }
    /**
     * Set IgnoreAfter value
     * @param bool $ignoreAfter
     * @return \Sabre\EnhancedAirBook\Structs\PostProcessing
     */
    public function setIgnoreAfter($ignoreAfter = null)
    {
        $this->IgnoreAfter = $ignoreAfter;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\PostProcessing
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
