<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PricedEquip Structs
 * @subpackage Structs
 */
class PricedEquip extends AbstractStructBase
{
    /**
     * The Equipment
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Equipment
     */
    public $Equipment;
    /**
     * Constructor method for PricedEquip
     * @uses PricedEquip::setEquipment()
     * @param \Sabre\EnhancedAirBook\Structs\Equipment $equipment
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\Equipment $equipment = null)
    {
        $this
            ->setEquipment($equipment);
    }
    /**
     * Get Equipment value
     * @return \Sabre\EnhancedAirBook\Structs\Equipment|null
     */
    public function getEquipment()
    {
        return $this->Equipment;
    }
    /**
     * Set Equipment value
     * @param \Sabre\EnhancedAirBook\Structs\Equipment $equipment
     * @return \Sabre\EnhancedAirBook\Structs\PricedEquip
     */
    public function setEquipment(\Sabre\EnhancedAirBook\Structs\Equipment $equipment = null)
    {
        $this->Equipment = $equipment;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\PricedEquip
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
