<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RailFareType Structs
 * @subpackage Structs
 */
class RailFareType extends AbstractStructBase
{
    /**
     * The Fare
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Fare[]
     */
    public $Fare;
    /**
     * Constructor method for RailFareType
     * @uses RailFareType::setFare()
     * @param \Sabre\EnhancedAirBook\Structs\Fare[] $fare
     */
    public function __construct(array $fare = array())
    {
        $this
            ->setFare($fare);
    }
    /**
     * Get Fare value
     * @return \Sabre\EnhancedAirBook\Structs\Fare[]|null
     */
    public function getFare()
    {
        return $this->Fare;
    }
    /**
     * Set Fare value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Fare[] $fare
     * @return \Sabre\EnhancedAirBook\Structs\RailFareType
     */
    public function setFare(array $fare = array())
    {
        $this->Fare = $fare;
        return $this;
    }
    /**
     * Add item to Fare value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Fare $item
     * @return \Sabre\EnhancedAirBook\Structs\RailFareType
     */
    public function addToFare(\Sabre\EnhancedAirBook\Structs\Fare $item)
    {
        $this->Fare[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\RailFareType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
