<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReservationItems Structs
 * @subpackage Structs
 */
class ReservationItems extends AbstractStructBase
{
    /**
     * The Item
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Item[]
     */
    public $Item;
    /**
     * Constructor method for ReservationItems
     * @uses ReservationItems::setItem()
     * @param \Sabre\EnhancedAirBook\Structs\Item[] $item
     */
    public function __construct(array $item = array())
    {
        $this
            ->setItem($item);
    }
    /**
     * Get Item value
     * @return \Sabre\EnhancedAirBook\Structs\Item[]|null
     */
    public function getItem()
    {
        return $this->Item;
    }
    /**
     * Set Item value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Item[] $item
     * @return \Sabre\EnhancedAirBook\Structs\ReservationItems
     */
    public function setItem(array $item = array())
    {
        $this->Item = $item;
        return $this;
    }
    /**
     * Add item to Item value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Item $item
     * @return \Sabre\EnhancedAirBook\Structs\ReservationItems
     */
    public function addToItem(\Sabre\EnhancedAirBook\Structs\Item $item)
    {
        $this->Item[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\ReservationItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
