<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SupplementaryServiceType Structs
 * @subpackage Structs
 */
class SupplementaryServiceType extends AbstractStructBase
{
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Sabre\EnhancedAirBook\Structs\Description[]
     */
    public $Description;
    /**
     * The Charges
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\ChargesType
     */
    public $Charges;
    /**
     * The PassengerReferences
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\PassengerReferences
     */
    public $PassengerReferences;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The code
     * @var string
     */
    public $code;
    /**
     * The codeContext
     * @var string
     */
    public $codeContext;
    /**
     * Constructor method for SupplementaryServiceType
     * @uses SupplementaryServiceType::setDescription()
     * @uses SupplementaryServiceType::setCharges()
     * @uses SupplementaryServiceType::setPassengerReferences()
     * @uses SupplementaryServiceType::setType()
     * @uses SupplementaryServiceType::setCode()
     * @uses SupplementaryServiceType::setCodeContext()
     * @param \Sabre\EnhancedAirBook\Structs\Description[] $description
     * @param \Sabre\EnhancedAirBook\Structs\ChargesType $charges
     * @param \Sabre\EnhancedAirBook\Structs\PassengerReferences $passengerReferences
     * @param string $type
     * @param string $code
     * @param string $codeContext
     */
    public function __construct(array $description = array(), \Sabre\EnhancedAirBook\Structs\ChargesType $charges = null, \Sabre\EnhancedAirBook\Structs\PassengerReferences $passengerReferences = null, $type = null, $code = null, $codeContext = null)
    {
        $this
            ->setDescription($description)
            ->setCharges($charges)
            ->setPassengerReferences($passengerReferences)
            ->setType($type)
            ->setCode($code)
            ->setCodeContext($codeContext);
    }
    /**
     * Get Description value
     * @return \Sabre\EnhancedAirBook\Structs\Description[]|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Description[] $description
     * @return \Sabre\EnhancedAirBook\Structs\SupplementaryServiceType
     */
    public function setDescription(array $description = array())
    {
        $this->Description = $description;
        return $this;
    }
    /**
     * Add item to Description value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\Description $item
     * @return \Sabre\EnhancedAirBook\Structs\SupplementaryServiceType
     */
    public function addToDescription(\Sabre\EnhancedAirBook\Structs\Description $item)
    {
        $this->Description[] = $item;
        return $this;
    }
    /**
     * Get Charges value
     * @return \Sabre\EnhancedAirBook\Structs\ChargesType|null
     */
    public function getCharges()
    {
        return $this->Charges;
    }
    /**
     * Set Charges value
     * @param \Sabre\EnhancedAirBook\Structs\ChargesType $charges
     * @return \Sabre\EnhancedAirBook\Structs\SupplementaryServiceType
     */
    public function setCharges(\Sabre\EnhancedAirBook\Structs\ChargesType $charges = null)
    {
        $this->Charges = $charges;
        return $this;
    }
    /**
     * Get PassengerReferences value
     * @return \Sabre\EnhancedAirBook\Structs\PassengerReferences|null
     */
    public function getPassengerReferences()
    {
        return $this->PassengerReferences;
    }
    /**
     * Set PassengerReferences value
     * @param \Sabre\EnhancedAirBook\Structs\PassengerReferences $passengerReferences
     * @return \Sabre\EnhancedAirBook\Structs\SupplementaryServiceType
     */
    public function setPassengerReferences(\Sabre\EnhancedAirBook\Structs\PassengerReferences $passengerReferences = null)
    {
        $this->PassengerReferences = $passengerReferences;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \Sabre\EnhancedAirBook\Structs\SupplementaryServiceType
     */
    public function setType($type = null)
    {
        $this->type = $type;
        return $this;
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \Sabre\EnhancedAirBook\Structs\SupplementaryServiceType
     */
    public function setCode($code = null)
    {
        $this->code = $code;
        return $this;
    }
    /**
     * Get codeContext value
     * @return string|null
     */
    public function getCodeContext()
    {
        return $this->codeContext;
    }
    /**
     * Set codeContext value
     * @param string $codeContext
     * @return \Sabre\EnhancedAirBook\Structs\SupplementaryServiceType
     */
    public function setCodeContext($codeContext = null)
    {
        $this->codeContext = $codeContext;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\SupplementaryServiceType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
