<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TimeSpan Structs
 * Meta informations extracted from the WSDL
 * - documentation: "TimeSpan" is used to return the specified stay dates associated with the particular hotel reservation.
 * @subpackage Structs
 */
class TimeSpan extends AbstractStructBase
{
    /**
     * The Duration
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $Duration;
    /**
     * The End
     * Meta informations extracted from the WSDL
     * - documentation: "End" follows this format: MM-DDTHH:MM | A simple date type. Allows specifying a date without a year. Accepted formats: "yyyy-mm-dd" or "mm-dd" | A simple date type. Allows specifying a date without a year. Accepted formats:
     * "yyyy-mm-dd" or "mm-dd"
     * - use: optional
     * - pattern:
     * (((((0[1-9])|(1[0-2]))-((0[1-9])|(1\d)|(2[0-9])))|((((0[13578])|(1[02]))-31)|(((0[1,3-9])|(1[0-2]))-30)))|(((19|20)(([02468][048])|([13579][26]))-02-29))|((20[0-9][0-9])|(19[0-9][0-9]))-((((0[1-9])|(1[0-2]))-((0[1-9])|(1\d)|(2[0-8])))|((((0[13578])|(
     * 1[02]))-31)|(((0[1,3-9])|(1[0-2]))-(29|30)))))
     * @var string
     */
    public $End;
    /**
     * The Start
     * Meta informations extracted from the WSDL
     * - documentation: "Start" follows this format: MM-DDTHHMM | A simple date type. Allows specifying a date without a year. Accepted formats: "yyyy-mm-dd" or "mm-dd" | A simple date type. Allows specifying a date without a year. Accepted formats:
     * "yyyy-mm-dd" or "mm-dd"
     * - use: optional
     * - pattern:
     * (((((0[1-9])|(1[0-2]))-((0[1-9])|(1\d)|(2[0-9])))|((((0[13578])|(1[02]))-31)|(((0[1,3-9])|(1[0-2]))-30)))|(((19|20)(([02468][048])|([13579][26]))-02-29))|((20[0-9][0-9])|(19[0-9][0-9]))-((((0[1-9])|(1[0-2]))-((0[1-9])|(1\d)|(2[0-8])))|((((0[13578])|(
     * 1[02]))-31)|(((0[1,3-9])|(1[0-2]))-(29|30)))))
     * @var string
     */
    public $Start;
    /**
     * Constructor method for TimeSpan
     * @uses TimeSpan::setDuration()
     * @uses TimeSpan::setEnd()
     * @uses TimeSpan::setStart()
     * @param string $duration
     * @param string $end
     * @param string $start
     */
    public function __construct($duration = null, $end = null, $start = null)
    {
        $this
            ->setDuration($duration)
            ->setEnd($end)
            ->setStart($start);
    }
    /**
     * Get Duration value
     * @return string|null
     */
    public function getDuration()
    {
        return $this->Duration;
    }
    /**
     * Set Duration value
     * @param string $duration
     * @return \Sabre\EnhancedAirBook\Structs\TimeSpan
     */
    public function setDuration($duration = null)
    {
        $this->Duration = $duration;
        return $this;
    }
    /**
     * Get End value
     * @return string|null
     */
    public function getEnd()
    {
        return $this->End;
    }
    /**
     * Set End value
     * @param string $end
     * @return \Sabre\EnhancedAirBook\Structs\TimeSpan
     */
    public function setEnd($end = null)
    {
        $this->End = $end;
        return $this;
    }
    /**
     * Get Start value
     * @return string|null
     */
    public function getStart()
    {
        return $this->Start;
    }
    /**
     * Set Start value
     * @param string $start
     * @return \Sabre\EnhancedAirBook\Structs\TimeSpan
     */
    public function setStart($start = null)
    {
        $this->Start = $start;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\TimeSpan
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
