<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TourCode Structs
 * @subpackage Structs
 */
class TourCode extends AbstractStructBase
{
    /**
     * The SuppressFareReplaceWithBT
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithBT
     */
    public $SuppressFareReplaceWithBT;
    /**
     * The SuppressFareReplaceWithIT
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithIT
     */
    public $SuppressFareReplaceWithIT;
    /**
     * The SuppressIT
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\SuppressIT
     */
    public $SuppressIT;
    /**
     * The SuppressITSupressFare
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\SuppressITSupressFare
     */
    public $SuppressITSupressFare;
    /**
     * The Text
     * Meta informations extracted from the WSDL
     * - documentation: "Text" is used to return the tour code. | "Text" is used to return tour code-related information.
     * - minOccurs: 0
     * @var string
     */
    public $Text;
    /**
     * Constructor method for TourCode
     * @uses TourCode::setSuppressFareReplaceWithBT()
     * @uses TourCode::setSuppressFareReplaceWithIT()
     * @uses TourCode::setSuppressIT()
     * @uses TourCode::setSuppressITSupressFare()
     * @uses TourCode::setText()
     * @param \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithBT $suppressFareReplaceWithBT
     * @param \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithIT $suppressFareReplaceWithIT
     * @param \Sabre\EnhancedAirBook\Structs\SuppressIT $suppressIT
     * @param \Sabre\EnhancedAirBook\Structs\SuppressITSupressFare $suppressITSupressFare
     * @param string $text
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithBT $suppressFareReplaceWithBT = null, \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithIT $suppressFareReplaceWithIT = null, \Sabre\EnhancedAirBook\Structs\SuppressIT $suppressIT = null, \Sabre\EnhancedAirBook\Structs\SuppressITSupressFare $suppressITSupressFare = null, $text = null)
    {
        $this
            ->setSuppressFareReplaceWithBT($suppressFareReplaceWithBT)
            ->setSuppressFareReplaceWithIT($suppressFareReplaceWithIT)
            ->setSuppressIT($suppressIT)
            ->setSuppressITSupressFare($suppressITSupressFare)
            ->setText($text);
    }
    /**
     * Get SuppressFareReplaceWithBT value
     * @return \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithBT|null
     */
    public function getSuppressFareReplaceWithBT()
    {
        return $this->SuppressFareReplaceWithBT;
    }
    /**
     * Set SuppressFareReplaceWithBT value
     * @param \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithBT $suppressFareReplaceWithBT
     * @return \Sabre\EnhancedAirBook\Structs\TourCode
     */
    public function setSuppressFareReplaceWithBT(\Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithBT $suppressFareReplaceWithBT = null)
    {
        $this->SuppressFareReplaceWithBT = $suppressFareReplaceWithBT;
        return $this;
    }
    /**
     * Get SuppressFareReplaceWithIT value
     * @return \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithIT|null
     */
    public function getSuppressFareReplaceWithIT()
    {
        return $this->SuppressFareReplaceWithIT;
    }
    /**
     * Set SuppressFareReplaceWithIT value
     * @param \Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithIT $suppressFareReplaceWithIT
     * @return \Sabre\EnhancedAirBook\Structs\TourCode
     */
    public function setSuppressFareReplaceWithIT(\Sabre\EnhancedAirBook\Structs\SuppressFareReplaceWithIT $suppressFareReplaceWithIT = null)
    {
        $this->SuppressFareReplaceWithIT = $suppressFareReplaceWithIT;
        return $this;
    }
    /**
     * Get SuppressIT value
     * @return \Sabre\EnhancedAirBook\Structs\SuppressIT|null
     */
    public function getSuppressIT()
    {
        return $this->SuppressIT;
    }
    /**
     * Set SuppressIT value
     * @param \Sabre\EnhancedAirBook\Structs\SuppressIT $suppressIT
     * @return \Sabre\EnhancedAirBook\Structs\TourCode
     */
    public function setSuppressIT(\Sabre\EnhancedAirBook\Structs\SuppressIT $suppressIT = null)
    {
        $this->SuppressIT = $suppressIT;
        return $this;
    }
    /**
     * Get SuppressITSupressFare value
     * @return \Sabre\EnhancedAirBook\Structs\SuppressITSupressFare|null
     */
    public function getSuppressITSupressFare()
    {
        return $this->SuppressITSupressFare;
    }
    /**
     * Set SuppressITSupressFare value
     * @param \Sabre\EnhancedAirBook\Structs\SuppressITSupressFare $suppressITSupressFare
     * @return \Sabre\EnhancedAirBook\Structs\TourCode
     */
    public function setSuppressITSupressFare(\Sabre\EnhancedAirBook\Structs\SuppressITSupressFare $suppressITSupressFare = null)
    {
        $this->SuppressITSupressFare = $suppressITSupressFare;
        return $this;
    }
    /**
     * Get Text value
     * @return string|null
     */
    public function getText()
    {
        return $this->Text;
    }
    /**
     * Set Text value
     * @param string $text
     * @return \Sabre\EnhancedAirBook\Structs\TourCode
     */
    public function setText($text = null)
    {
        $this->Text = $text;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\TourCode
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
