<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserInfo Structs
 * @subpackage Structs
 */
class UserInfo extends AbstractStructBase
{
    /**
     * The AAACity
     * @var \Sabre\EnhancedAirBook\Structs\AAACity
     */
    public $AAACity;
    /**
     * The Action
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Action
     */
    public $Action;
    /**
     * The AgentSine
     * @var \Sabre\EnhancedAirBook\Structs\AgentSine
     */
    public $AgentSine;
    /**
     * The Branch
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Branch
     */
    public $Branch;
    /**
     * The Partition
     * @var \Sabre\EnhancedAirBook\Structs\Partition
     */
    public $Partition;
    /**
     * The Service
     * @var \Sabre\EnhancedAirBook\Structs\Service
     */
    public $Service;
    /**
     * The SetAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $SetAddress;
    /**
     * The Station
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Station
     */
    public $Station;
    /**
     * The Transaction
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\Transaction
     */
    public $Transaction;
    /**
     * Constructor method for UserInfo
     * @uses UserInfo::setAAACity()
     * @uses UserInfo::setAction()
     * @uses UserInfo::setAgentSine()
     * @uses UserInfo::setBranch()
     * @uses UserInfo::setPartition()
     * @uses UserInfo::setService()
     * @uses UserInfo::setSetAddress()
     * @uses UserInfo::setStation()
     * @uses UserInfo::setTransaction()
     * @param \Sabre\EnhancedAirBook\Structs\AAACity $aAACity
     * @param \Sabre\EnhancedAirBook\Structs\Action $action
     * @param \Sabre\EnhancedAirBook\Structs\AgentSine $agentSine
     * @param \Sabre\EnhancedAirBook\Structs\Branch $branch
     * @param \Sabre\EnhancedAirBook\Structs\Partition $partition
     * @param \Sabre\EnhancedAirBook\Structs\Service $service
     * @param string $setAddress
     * @param \Sabre\EnhancedAirBook\Structs\Station $station
     * @param \Sabre\EnhancedAirBook\Structs\Transaction $transaction
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\AAACity $aAACity = null, \Sabre\EnhancedAirBook\Structs\Action $action = null, \Sabre\EnhancedAirBook\Structs\AgentSine $agentSine = null, \Sabre\EnhancedAirBook\Structs\Branch $branch = null, \Sabre\EnhancedAirBook\Structs\Partition $partition = null, \Sabre\EnhancedAirBook\Structs\Service $service = null, $setAddress = null, \Sabre\EnhancedAirBook\Structs\Station $station = null, \Sabre\EnhancedAirBook\Structs\Transaction $transaction = null)
    {
        $this
            ->setAAACity($aAACity)
            ->setAction($action)
            ->setAgentSine($agentSine)
            ->setBranch($branch)
            ->setPartition($partition)
            ->setService($service)
            ->setSetAddress($setAddress)
            ->setStation($station)
            ->setTransaction($transaction);
    }
    /**
     * Get AAACity value
     * @return \Sabre\EnhancedAirBook\Structs\AAACity|null
     */
    public function getAAACity()
    {
        return $this->AAACity;
    }
    /**
     * Set AAACity value
     * @param \Sabre\EnhancedAirBook\Structs\AAACity $aAACity
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setAAACity(\Sabre\EnhancedAirBook\Structs\AAACity $aAACity = null)
    {
        $this->AAACity = $aAACity;
        return $this;
    }
    /**
     * Get Action value
     * @return \Sabre\EnhancedAirBook\Structs\Action|null
     */
    public function getAction()
    {
        return $this->Action;
    }
    /**
     * Set Action value
     * @param \Sabre\EnhancedAirBook\Structs\Action $action
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setAction(\Sabre\EnhancedAirBook\Structs\Action $action = null)
    {
        $this->Action = $action;
        return $this;
    }
    /**
     * Get AgentSine value
     * @return \Sabre\EnhancedAirBook\Structs\AgentSine|null
     */
    public function getAgentSine()
    {
        return $this->AgentSine;
    }
    /**
     * Set AgentSine value
     * @param \Sabre\EnhancedAirBook\Structs\AgentSine $agentSine
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setAgentSine(\Sabre\EnhancedAirBook\Structs\AgentSine $agentSine = null)
    {
        $this->AgentSine = $agentSine;
        return $this;
    }
    /**
     * Get Branch value
     * @return \Sabre\EnhancedAirBook\Structs\Branch|null
     */
    public function getBranch()
    {
        return $this->Branch;
    }
    /**
     * Set Branch value
     * @param \Sabre\EnhancedAirBook\Structs\Branch $branch
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setBranch(\Sabre\EnhancedAirBook\Structs\Branch $branch = null)
    {
        $this->Branch = $branch;
        return $this;
    }
    /**
     * Get Partition value
     * @return \Sabre\EnhancedAirBook\Structs\Partition|null
     */
    public function getPartition()
    {
        return $this->Partition;
    }
    /**
     * Set Partition value
     * @param \Sabre\EnhancedAirBook\Structs\Partition $partition
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setPartition(\Sabre\EnhancedAirBook\Structs\Partition $partition = null)
    {
        $this->Partition = $partition;
        return $this;
    }
    /**
     * Get Service value
     * @return \Sabre\EnhancedAirBook\Structs\Service|null
     */
    public function getService()
    {
        return $this->Service;
    }
    /**
     * Set Service value
     * @param \Sabre\EnhancedAirBook\Structs\Service $service
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setService(\Sabre\EnhancedAirBook\Structs\Service $service = null)
    {
        $this->Service = $service;
        return $this;
    }
    /**
     * Get SetAddress value
     * @return string|null
     */
    public function getSetAddress()
    {
        return $this->SetAddress;
    }
    /**
     * Set SetAddress value
     * @param string $setAddress
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setSetAddress($setAddress = null)
    {
        $this->SetAddress = $setAddress;
        return $this;
    }
    /**
     * Get Station value
     * @return \Sabre\EnhancedAirBook\Structs\Station|null
     */
    public function getStation()
    {
        return $this->Station;
    }
    /**
     * Set Station value
     * @param \Sabre\EnhancedAirBook\Structs\Station $station
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setStation(\Sabre\EnhancedAirBook\Structs\Station $station = null)
    {
        $this->Station = $station;
        return $this;
    }
    /**
     * Get Transaction value
     * @return \Sabre\EnhancedAirBook\Structs\Transaction|null
     */
    public function getTransaction()
    {
        return $this->Transaction;
    }
    /**
     * Set Transaction value
     * @param \Sabre\EnhancedAirBook\Structs\Transaction $transaction
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public function setTransaction(\Sabre\EnhancedAirBook\Structs\Transaction $transaction = null)
    {
        $this->Transaction = $transaction;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\UserInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
