<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VCR Structs
 * @subpackage Structs
 */
class VCR extends AbstractStructBase
{
    /**
     * The TicketingDocument
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sabre\EnhancedAirBook\Structs\TicketingDocument[]
     */
    public $TicketingDocument;
    /**
     * Constructor method for VCR
     * @uses VCR::setTicketingDocument()
     * @param \Sabre\EnhancedAirBook\Structs\TicketingDocument[] $ticketingDocument
     */
    public function __construct(array $ticketingDocument = array())
    {
        $this
            ->setTicketingDocument($ticketingDocument);
    }
    /**
     * Get TicketingDocument value
     * @return \Sabre\EnhancedAirBook\Structs\TicketingDocument[]|null
     */
    public function getTicketingDocument()
    {
        return $this->TicketingDocument;
    }
    /**
     * Set TicketingDocument value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\TicketingDocument[] $ticketingDocument
     * @return \Sabre\EnhancedAirBook\Structs\VCR
     */
    public function setTicketingDocument(array $ticketingDocument = array())
    {
        $this->TicketingDocument = $ticketingDocument;
        return $this;
    }
    /**
     * Add item to TicketingDocument value
     * @throws \InvalidArgumentException
     * @param \Sabre\EnhancedAirBook\Structs\TicketingDocument $item
     * @return \Sabre\EnhancedAirBook\Structs\VCR
     */
    public function addToTicketingDocument(\Sabre\EnhancedAirBook\Structs\TicketingDocument $item)
    {
        $this->TicketingDocument[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\VCR
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
