<?php

namespace Sabre\EnhancedAirBook\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for STL_Notif_Payload Structs
 * Meta informations extracted from the WSDL
 * - documentation: Global message element for service notifications. | Base type for notification messages.
 * - substitutionGroup: STL_Payload
 * - type: STL_Notif_Payload
 * @subpackage Structs
 */
abstract class STL_Notif_Payload extends STL_Payload
{
    /**
     * The ApplicationResults
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: ApplicationResults
     * @var \Sabre\EnhancedAirBook\Structs\ApplicationResults
     */
    public $ApplicationResults;
    /**
     * Constructor method for STL_Notif_Payload
     * @uses STL_Notif_Payload::setApplicationResults()
     * @param \Sabre\EnhancedAirBook\Structs\ApplicationResults $applicationResults
     */
    public function __construct(\Sabre\EnhancedAirBook\Structs\ApplicationResults $applicationResults = null)
    {
        $this
            ->setApplicationResults($applicationResults);
    }
    /**
     * Get ApplicationResults value
     * @return \Sabre\EnhancedAirBook\Structs\ApplicationResults|null
     */
    public function getApplicationResults()
    {
        return $this->ApplicationResults;
    }
    /**
     * Set ApplicationResults value
     * @param \Sabre\EnhancedAirBook\Structs\ApplicationResults $applicationResults
     * @return \Sabre\EnhancedAirBook\Structs\STL_Notif_Payload
     */
    public function setApplicationResults(\Sabre\EnhancedAirBook\Structs\ApplicationResults $applicationResults = null)
    {
        $this->ApplicationResults = $applicationResults;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\EnhancedAirBook\Structs\STL_Notif_Payload
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
